<?php

namespace Teknisa\CADCTB\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\DateUtil;
use Teknisa\Model\Geral\Entities\Filial;

class Ger06300CentroDeCustoFactory{
    
    protected $entityManager;
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    public function getFilial($parans){
        $filial = $this->entityManager->getRepository(Filial::class)->findOneBy($parans);
        return $filial;
    }
    
    public function deleteFilial($cdfilial) {
        // Query a ser executada.
        $sql = "DELETE FROM CENTCUSTFIL WHERE CDFILIAL = :CDFILIAL";

        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "CDFILIAL"     => $cdfilial
        );
    
    
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
    }
    
    public function saveFilial($params) {
        // Query a ser executada.
        $sql = "INSERT INTO CENTCUSTFIL (CDFILIAL,
                                        CDOPERINCLUSAO, 
                                        CDOPERULTATU, 
                                        CDCENTCUST, 
                                        DTINCLUSAO, 
                                        DTULTATU, 
                                        IDATIVO, 
                                        NRORG, 
                                        NRORGINCLUSAO, 
                                        NRORGULTATU) 
                              VALUES (  :CDFILIAL, 
                                        :CDOPERINCLUSAO, 
                                        :CDOPERULTATU, 
                                        :CDCENTCUST, 
                                        :DTINCLUSAO, 
                                        :DTULTATU, 
                                        :IDATIVO, 
                                        :NRORG, 
                                        :NRORGINCLUSAO, 
                                        :NRORGULTATU)";

        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
    }
    
    public function selectEmpresa($cdfilial,$cdcentcust) { 
    
        $sql = "SELECT * FROM CENTCUSTFIL 
                 WHERE CDFILIAL = :CDFILIAL 
                 AND CDCENTCUST = :CDCENTCUST";
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "CDFILIAL"       => $cdfilial,
            "CDCENTCUST"     => $cdcentcust,
        );
        
        $std->execute($params);
        
        return $std->fetch();
        
    }
    
}

